package com.zhongzheng.modules.inform.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.zhongzheng.common.utils.DateUtils;
import org.apache.commons.math3.distribution.AbstractMultivariateRealDistribution;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.inform.bo.InformClassifyAddBo;
import com.zhongzheng.modules.inform.bo.InformClassifyQueryBo;
import com.zhongzheng.modules.inform.bo.InformClassifyEditBo;
import com.zhongzheng.modules.inform.domain.InformClassify;
import com.zhongzheng.modules.inform.mapper.InformClassifyMapper;
import com.zhongzheng.modules.inform.vo.InformClassifyVo;
import com.zhongzheng.modules.inform.service.IInformClassifyService;
import org.springframework.transaction.annotation.Transactional;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 【请填写功能名称】Service业务层处理
 *
 * @author ruoyi
 * @date 2021-11-23
 */
@Service
public class InformClassifyServiceImpl extends ServiceImpl<InformClassifyMapper, InformClassify> implements IInformClassifyService {

    @Override
    public InformClassifyVo queryById(Long classifyId){
        InformClassify db = this.baseMapper.selectById(classifyId);
        return BeanUtil.toBean(db, InformClassifyVo.class);
    }

    @Override
    public List<InformClassifyVo> queryList(InformClassifyQueryBo bo) {
        LambdaQueryWrapper<InformClassify> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getParentId() != null, InformClassify::getParentId, bo.getParentId());
        lqw.like(StrUtil.isNotBlank(bo.getClassifyName()), InformClassify::getClassifyName, bo.getClassifyName());
        lqw.in(bo.getStatus() != null, InformClassify::getStatus, bo.getStatus());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<InformClassifyVo> entity2Vo(Collection<InformClassify> collection) {
        List<InformClassifyVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, InformClassifyVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<InformClassify> page = (Page<InformClassify>)collection;
            Page<InformClassifyVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(InformClassifyAddBo bo) {
        InformClassify add = BeanUtil.toBean(bo, InformClassify.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean updateByEditBo(InformClassifyEditBo bo) {
        InformClassify update = BeanUtil.toBean(bo, InformClassify.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        if (bo.getStatus() == -1) {
            findCompanyAndDepts(bo);
        }
        return this.updateById(update);
    }

    public Boolean findCompanyAndDepts(InformClassifyEditBo bo){
        LambdaQueryWrapper<InformClassify> lqw = Wrappers.lambdaQuery();
        lqw.eq(InformClassify::getParentId, bo.getClassifyId());
        List<InformClassify> list = this.list(lqw);
        if(CollectionUtils.isNotEmpty(list)){
            for (InformClassify informClassify : list) {
                lqw.clear();
                lqw.eq(InformClassify::getClassifyId, informClassify.getClassifyId());
                informClassify.setStatus(-1);
                informClassify.setUpdateTime(DateUtils.getNowTime());
                baseMapper.update(informClassify, lqw);
                getDepts(informClassify.getClassifyId());
            }

        }
        return true;
    }

    /**
     * @descript:递归
     * @param
     * @return
     */
    public Boolean getDepts(Long id){
        LambdaQueryWrapper<InformClassify> lqw = Wrappers.lambdaQuery();
        lqw.eq(InformClassify::getParentId, id);
        List<InformClassify> list = this.list(lqw);
        if(CollectionUtils.isNotEmpty(list)){
            for (InformClassify informClassify : list) {
                lqw.clear();
                lqw.eq(InformClassify::getClassifyId, informClassify.getClassifyId());
                informClassify.setStatus(-1);
                informClassify.setUpdateTime(DateUtils.getNowTime());
                getDepts(informClassify.getClassifyId());
                baseMapper.update(informClassify, lqw);
            }

        }
        return true;
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(InformClassify entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
